using System;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationTRTAMIS
{
    public class TRTAMIS2020
    {
    
    public string RPId = null;
    public bool RPExists = false;
    public int RPCount = 0;
    public int RPOccurrenceIndex = 0;
    public int RPLastOccurrenceIndex = 0;
    public string RPIdentifier = null;
    public string RPIdentifierScheme = null;
        public string RPIdentifierTFN = null;
        public DateTime? RPStartDate = null;
        public DateTime? RPEndDate = null;

        /// <summary>
        /// RP:tns:ContextPeriodStartDate
        /// </summary>
        public DateTime? TRTAMIS2 = null;

        /// <summary>
        /// RP:tns:ContextPeriodEndDate
        /// </summary>
        public DateTime? TRTAMIS3 = null;

        /// <summary>
        /// RP:tns:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string TRTAMIS1 = null;

        /// <summary>
        /// RP:tns:Report.TargetFinancial.Year
        /// </summary>
        public int? TRTAMIS4 = null;

        /// <summary>
        /// RP:tns:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string TRTAMIS5 = null;

        /// <summary>
        /// RP:tns:IncomeTax.AttributionManagedInvestmentTrustClass.Description
        /// </summary>
        public string TRTAMIS313 = null;

        /// <summary>
        /// RP:tns:Lodgment.FinalReturn.Indicator
        /// </summary>
        public bool? TRTAMIS317 = null;

        /// <summary>
        /// RP:tns:IncomeTax.AttributionManagedInvestmentTrustClassMembers.Count
        /// </summary>
        public decimal? TRTAMIS323 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.DeductionDebt.Amount
        /// </summary>
        public decimal? TRTAMIS335 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.BalanceOfTaxLossesBroughtForwardFromPriorYear.Amount
        /// </summary>
        public decimal? TRTAMIS309 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.Uplift.Amount
        /// </summary>
        public decimal? TRTAMIS318 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.ForgivenDebtNet.Amount
        /// </summary>
        public decimal? TRTAMIS319 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.Incurred.Amount
        /// </summary>
        public decimal? TRTAMIS320 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.ExemptIncomeNet.Amount
        /// </summary>
        public decimal? TRTAMIS321 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.Forgone.Amount
        /// </summary>
        public decimal? TRTAMIS322 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.Deducted.Amount
        /// </summary>
        public decimal? TRTAMIS310 = null;

        /// <summary>
        /// RP:tns:Tax.Losses.CarriedForward.LaterIncomeYearsTotal.Amount
        /// </summary>
        public decimal? TRTAMIS311 = null;

        public string RPInstantId = null;
        public bool RPInstantExists = false;
        public int RPInstantCount = 0;
        public int RPInstantOccurrenceIndex = 0;
        public int RPInstantLastOccurrenceIndex = 0;
        public string RPInstantIdentifier = null;
        public string RPInstantIdentifierScheme = null;
        public string RPInstantIdentifierTFN = null;
        public DateTime? RPInstantInstantDate = null;

        /// <summary>
        /// RPInstant:tns:Assets.Total.Amount
        /// </summary>
        public decimal? TRTAMIS333 = null;

        /// <summary>
        /// RPInstant:tns:Liabilities.Total.Amount
        /// </summary>
        public decimal? TRTAMIS334 = null;

        public string RPNetExemptionIncomeId = null;
        public bool RPNetExemptionIncomeExists = false;
        public int RPNetExemptionIncomeCount = 0;
        public int RPNetExemptionIncomeOccurrenceIndex = 0;
        public int RPNetExemptionIncomeLastOccurrenceIndex = 0;
        public string RPNetExemptionIncomeIdentifier = null;
        public string RPNetExemptionIncomeIdentifierScheme = null;
        public string RPNetExemptionIncomeIdentifierTFN = null;
        public DateTime? RPNetExemptionIncomeStartDate = null;
        public DateTime? RPNetExemptionIncomeEndDate = null;

        /// <summary>
        /// RPNetExemptionIncome:tns:Income.Net.Amount
        /// </summary>
        public decimal? TRTAMIS285 = null;

        public string RPNonAssessableNonExemptAmountsId = null;
        public bool RPNonAssessableNonExemptAmountsExists = false;
        public int RPNonAssessableNonExemptAmountsCount = 0;
        public int RPNonAssessableNonExemptAmountsOccurrenceIndex = 0;
        public int RPNonAssessableNonExemptAmountsLastOccurrenceIndex = 0;
        public string RPNonAssessableNonExemptAmountsIdentifier = null;
        public string RPNonAssessableNonExemptAmountsIdentifierScheme = null;
        public string RPNonAssessableNonExemptAmountsIdentifierTFN = null;
        public DateTime? RPNonAssessableNonExemptAmountsStartDate = null;
        public DateTime? RPNonAssessableNonExemptAmountsEndDate = null;

        /// <summary>
        /// RPNonAssessableNonExemptAmounts:tns:Income.Net.Amount
        /// </summary>
        public decimal? TRTAMIS332 = null;

        public string RPOffsetId = null;
        public bool RPOffsetExists = false;
        public int RPOffsetCount = 0;
        public int RPOffsetOccurrenceIndex = 0;
        public int RPOffsetLastOccurrenceIndex = 0;
        public string RPOffsetIdentifier = null;
        public string RPOffsetIdentifierScheme = null;
        public string RPOffsetIdentifierTFN = null;
        public DateTime? RPOffsetStartDate = null;
        public DateTime? RPOffsetEndDate = null;

        /// <summary>
        /// RPOffset:tns:Income.TrustComponent.Amount
        /// </summary>
        public decimal? TRTAMIS295 = null;

        /// <summary>
        /// RPOffset:tns:Income.UnderstatedEntitlement.Amount
        /// </summary>
        public decimal? TRTAMIS296 = null;

        /// <summary>
        /// RPOffset:tns:Expense.Overstated.Amount
        /// </summary>
        public decimal? TRTAMIS297 = null;

        /// <summary>
        /// RPOffset:tns:Income.Net.Amount
        /// </summary>
        public decimal? TRTAMIS299 = null;

        /// <summary>
        /// RPOffset:tns:Income.TrustDeficitComponent.Amount
        /// </summary>
        public decimal? TRTAMIS300 = null;

        public string RPAssessableIncomeOtherThanCapitalGainsId = null;
        public bool RPAssessableIncomeOtherThanCapitalGainsExists = false;
        public int RPAssessableIncomeOtherThanCapitalGainsCount = 0;
        public int RPAssessableIncomeOtherThanCapitalGainsOccurrenceIndex = 0;
        public int RPAssessableIncomeOtherThanCapitalGainsLastOccurrenceIndex = 0;
        public string RPAssessableIncomeOtherThanCapitalGainsIdentifier = null;
        public string RPAssessableIncomeOtherThanCapitalGainsIdentifierScheme = null;
        public string RPAssessableIncomeOtherThanCapitalGainsIdentifierTFN = null;
        public DateTime? RPAssessableIncomeOtherThanCapitalGainsStartDate = null;
        public DateTime? RPAssessableIncomeOtherThanCapitalGainsEndDate = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGains:tns:Income.Taxable.Amount
        /// </summary>
        public decimal? TRTAMIS260 = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGains:tns:Income.NonConcessionalManagedInvestmentTrust.Amount
        /// </summary>
        public decimal? TRTAMIS336 = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGains:tns:Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount
        /// </summary>
        public decimal? TRTAMIS337 = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGains:tns:Income.TrustComponent.Amount
        /// </summary>
        public decimal? TRTAMIS314 = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGains:tns:Income.UnderstatedEntitlement.Amount
        /// </summary>
        public decimal? TRTAMIS315 = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGains:tns:Expense.Overstated.Amount
        /// </summary>
        public decimal? TRTAMIS316 = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGains:tns:Expense.CarryForwardTrustComponentDeficit.Amount
        /// </summary>
        public decimal? TRTAMIS265 = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGains:tns:Income.Net.Amount
        /// </summary>
        public decimal? TRTAMIS266 = null;

        public string RPAssessableIncomeOtherThanCapitalGainsDirectId = null;
        public bool RPAssessableIncomeOtherThanCapitalGainsDirectExists = false;
        public int RPAssessableIncomeOtherThanCapitalGainsDirectCount = 0;
        public int RPAssessableIncomeOtherThanCapitalGainsDirectOccurrenceIndex = 0;
        public int RPAssessableIncomeOtherThanCapitalGainsDirectLastOccurrenceIndex = 0;
        public string RPAssessableIncomeOtherThanCapitalGainsDirectIdentifier = null;
        public string RPAssessableIncomeOtherThanCapitalGainsDirectIdentifierScheme = null;
        public string RPAssessableIncomeOtherThanCapitalGainsDirectIdentifierTFN = null;
        public DateTime? RPAssessableIncomeOtherThanCapitalGainsDirectStartDate = null;
        public DateTime? RPAssessableIncomeOtherThanCapitalGainsDirectEndDate = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGainsDirect:tns:Expense.DeductionsTotal.Amount
        /// </summary>
        public decimal? TRTAMIS261 = null;

        public string RPAssessableIncomeOtherThanCapitalGainsIndirectId = null;
        public bool RPAssessableIncomeOtherThanCapitalGainsIndirectExists = false;
        public int RPAssessableIncomeOtherThanCapitalGainsIndirectCount = 0;
        public int RPAssessableIncomeOtherThanCapitalGainsIndirectOccurrenceIndex = 0;
        public int RPAssessableIncomeOtherThanCapitalGainsIndirectLastOccurrenceIndex = 0;
        public string RPAssessableIncomeOtherThanCapitalGainsIndirectIdentifier = null;
        public string RPAssessableIncomeOtherThanCapitalGainsIndirectIdentifierScheme = null;
        public string RPAssessableIncomeOtherThanCapitalGainsIndirectIdentifierTFN = null;
        public DateTime? RPAssessableIncomeOtherThanCapitalGainsIndirectStartDate = null;
        public DateTime? RPAssessableIncomeOtherThanCapitalGainsIndirectEndDate = null;

        /// <summary>
        /// RPAssessableIncomeOtherThanCapitalGainsIndirect:tns:Expense.DeductionsOther.Amount
        /// </summary>
        public decimal? TRTAMIS262 = null;

        public string RPAssessableIncomeCapitalGainsId = null;
        public bool RPAssessableIncomeCapitalGainsExists = false;
        public int RPAssessableIncomeCapitalGainsCount = 0;
        public int RPAssessableIncomeCapitalGainsOccurrenceIndex = 0;
        public int RPAssessableIncomeCapitalGainsLastOccurrenceIndex = 0;
        public string RPAssessableIncomeCapitalGainsIdentifier = null;
        public string RPAssessableIncomeCapitalGainsIdentifierScheme = null;
        public string RPAssessableIncomeCapitalGainsIdentifierTFN = null;
        public DateTime? RPAssessableIncomeCapitalGainsStartDate = null;
        public DateTime? RPAssessableIncomeCapitalGainsEndDate = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGains:tns:Income.CapitalGainsNetCredit.Amount
        /// </summary>
        public decimal? TRTAMIS324 = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGains:tns:Income.NonConcessionalManagedInvestmentTrust.Amount
        /// </summary>
        public decimal? TRTAMIS338 = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGains:tns:Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount
        /// </summary>
        public decimal? TRTAMIS339 = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGains:tns:Income.TrustComponent.Amount
        /// </summary>
        public decimal? TRTAMIS327 = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGains:tns:Income.UnderstatedEntitlement.Amount
        /// </summary>
        public decimal? TRTAMIS328 = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGains:tns:Expense.Overstated.Amount
        /// </summary>
        public decimal? TRTAMIS329 = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGains:tns:Income.Net.Amount
        /// </summary>
        public decimal? TRTAMIS330 = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGains:tns:Expense.CarryForwardTrustComponentDeficit.Amount
        /// </summary>
        public decimal? TRTAMIS331 = null;

        public string RPAssessableIncomeCapitalGainsDirectId = null;
        public bool RPAssessableIncomeCapitalGainsDirectExists = false;
        public int RPAssessableIncomeCapitalGainsDirectCount = 0;
        public int RPAssessableIncomeCapitalGainsDirectOccurrenceIndex = 0;
        public int RPAssessableIncomeCapitalGainsDirectLastOccurrenceIndex = 0;
        public string RPAssessableIncomeCapitalGainsDirectIdentifier = null;
        public string RPAssessableIncomeCapitalGainsDirectIdentifierScheme = null;
        public string RPAssessableIncomeCapitalGainsDirectIdentifierTFN = null;
        public DateTime? RPAssessableIncomeCapitalGainsDirectStartDate = null;
        public DateTime? RPAssessableIncomeCapitalGainsDirectEndDate = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGainsDirect:tns:Expense.DeductionsTotal.Amount
        /// </summary>
        public decimal? TRTAMIS325 = null;

        public string RPAssessableIncomeCapitalGainsIndirectId = null;
        public bool RPAssessableIncomeCapitalGainsIndirectExists = false;
        public int RPAssessableIncomeCapitalGainsIndirectCount = 0;
        public int RPAssessableIncomeCapitalGainsIndirectOccurrenceIndex = 0;
        public int RPAssessableIncomeCapitalGainsIndirectLastOccurrenceIndex = 0;
        public string RPAssessableIncomeCapitalGainsIndirectIdentifier = null;
        public string RPAssessableIncomeCapitalGainsIndirectIdentifierScheme = null;
        public string RPAssessableIncomeCapitalGainsIndirectIdentifierTFN = null;
        public DateTime? RPAssessableIncomeCapitalGainsIndirectStartDate = null;
        public DateTime? RPAssessableIncomeCapitalGainsIndirectEndDate = null;

        /// <summary>
        /// RPAssessableIncomeCapitalGainsIndirect:tns:Expense.DeductionsOther.Amount
        /// </summary>
        public decimal? TRTAMIS326 = null;

    }
}
